#define	MAXROB 24

#define msdos 1
/*#define djgpp 1*/
/* da ELIMINARE x compilare in LINUX
*/


#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<time.h>
#ifdef linux
#include	<termio.h>
#include	<curses.h>
#else
#include 	<process.h>
#include	<conio.h>
#include	<io.h>
#include        <sys\stat.h>
#endif

#ifdef	msdos
void	patch();
#endif
void	scambia(int i,int j,char *in);
void	mischia(int j, char *in);
int	getval(char *from);
void 	analisi();
void	aggiorna(unsigned int nr);
void	finale();
void	init(FILE *fp, char status);
void	stampa(FILE *fp, int maxrow, unsigned int nr);
#ifdef linux
void	stampaw(int nr);
#endif
void	save(int k);
void	esci();
void	scambiaf2f(int i,int j,char *in);
void 	analisif2f();
void	mischiaf2f(int j, char *in);
void	uso();
void	errore(char status);
void	comando(char* cm, int argc, char *argv[]);
#ifndef __TURBOC__
	void    randomize(void);
#endif

#ifdef msdos
void refresh(void);
void initscr(void);
void cbreak(void);
void noecho(void);
void curs_set(int x);
void endwin(void);
#endif

int	numrob=0,limrob=0;
int	numinc=0,mnuminc=0;
char	rob[MAXROB+1][50];
char	srob[MAXROB+1][50];
long	data[MAXROB+1][4];
long	c=0,bias=0;
int	matches=100;
char	*in;
char	fileout[50]="parziali.txt";
char	isfileout=0;
char	temp[128];
char	log=0;
FILE	*flog;
char	extcount[100];
char	ordine=0;
int	rep=1;
int	win=3;
int	pari=1;
char	rtest=0,mtest=0;
char	quiet=0;
char	f2f=0;
char	versio[50]="TORNEO 2K v1.5";
char	robstring[100]="torneo.rob";
char	dirstring[100];
char	outstring[100];
char	fake=0;
char 	fk[6]="";

#ifdef linux
	#define clrscr clear
#else
	#define clear clrscr
	#define printw printf
#endif


int main(int argc, char *argv[])
{
	unsigned int 	k;
	long	L;
	char	i,j,z,exitmode=0;
	int	rp;
	char	parameter[256],r[80];
	char    pars[256],nr[10];
	FILE	*fp;
	char	nuovo=0;

	outstring[0]=0;
	extcount[0]=0;

	if (argc!=1) {
		if(!strcmp(argv[1],"save")) comando("save",argc,argv);
		else if(!strcmp(argv[1],"quit")) comando("quit",argc,argv);
		else if(!strcmp(argv[1],"agg")) comando("aggiorna",argc,argv);

		else for(k=1;k<argc;k++)
		{
			if(argv[k][0]=='-') {
				if((tolower(argv[k][1]))=='f') f2f=1;
				else if((tolower(argv[k][1]))=='r') {
					rtest=1;
					strcpy(rob[0],(argv[k]+3));
				}
				else if((tolower(argv[k][1]))=='m') {
					mtest=1;
					mnuminc=getval(argv[k]);
				}
				else if((tolower(argv[k][1]))=='o') ordine=1;
				else if((tolower(argv[k][1]))=='x') rep=0;
				else if((tolower(argv[k][1]))=='t') log=1;
				else if((tolower(argv[k][1]))=='l') limrob=getval(argv[k]);
			#ifdef linux
				else if((tolower(argv[k][1]))=='q') quiet=1;
			#endif
				else if((tolower(argv[k][1]))=='w') win=getval(argv[k]);
				else if((tolower(argv[k][1]))=='p') pari=getval(argv[k]);
				else if((tolower(argv[k][1]))=='d') strcpy(outstring,(argv[k]+3));
				else if((tolower(argv[k][1]))=='c') strcpy(extcount,(argv[k]+3));

			}
			else strcpy(robstring,argv[k]);
		}


	}
	remove("cmnd");
	if(!quiet) {
		printf("\n\n\n\n\nCROBOTS %s\nCopyright (C) Michelangelo Messina\n",versio);
		printf("e-mail m.messina@tiscalinet.it\n       m.messina@libero.it\n\n\n\n");
	}

	if((in=(char *)calloc((MAXROB*(MAXROB-1)*(MAXROB-2)*(MAXROB-3)/6)+1,sizeof(char)))==NULL) {
		printf("Memoria non allocata\n");
		exit(-1);
	}


	if(!strstr(robstring,".")) strcat(robstring,".rob");
	if(!outstring[0]) {
		strcpy(outstring,robstring);
		while(strstr(outstring,"\\"))strcpy(outstring,strstr(outstring,"\\")+1);
		while(strstr(outstring,"/"))strcpy(outstring,strstr(outstring,"/")+1);
		if(strstr(outstring,".")) *(strstr(outstring,"."))=0;
		strcpy(dirstring,outstring);
		strcat(outstring,".sco");
	} else {
		strcpy(dirstring,outstring);
		if(strstr(dirstring,".")) *(strstr(dirstring,"."))=0;
		while(strstr(dirstring,"\\"))strcpy(dirstring,strstr(dirstring,"\\")+1);
		while(strstr(dirstring,"/"))strcpy(dirstring,strstr(dirstring,"/")+1);
		if(!strstr(outstring,".")) strcat(outstring,".sco");

	}
	strcpy(fileout,outstring);

	if(!quiet) {
		initscr();
		cbreak();
		noecho();

		clear();
		curs_set(0);
		printw("CROBOTS %s\nCopyright (C) Michelangelo Messina\n",versio);
		printw("e-mail mmessina@tiscalinet.it\n       m.messina@libero.it\n\n\n\n");
		printw("Un ringraziamento speciale a\n TOM POINTEXTER - autore del programma CROBOTS\n\n\n");
		printw("\n\nDedicato a tutti gli amanti di Crobots\n\n");
		if(f2f) printw("\n\nModalita' Face2Face");
		else printw("\n\n");
		printw("\n\n Premi un tasto\n");
		refresh();
		#ifdef msdos
			while(!kbhit());
		#endif
		getch();
		clear();
	}


	strcpy(temp,dirstring);
	strcat(temp,".dat");
	if((fp=fopen(temp,"rt"))!=NULL) {
		if(!quiet) {
			printw("\nHo trovato un salvataggio precedente !\n");
			printw("Digitare N se si vuole iniziare un nuovo torneo (i vecchi dati saranno persi)\n");
		#ifdef linux
			refresh();
			if((z=getchar())=='N' || z=='n') {
		#else
			while(!kbhit());
			if((z=getch())=='N' || z=='n') {
		#endif
				nuovo=1;
				fclose (fp);
				remove(temp);
			}
		}
	}
	else nuovo=1;
	if (nuovo) {
		if(!quiet) {
			printw("\nInizio un nuovo torneo\n\n");
			printw("\n\n\nDurante il torneo:\nS: salva la situazione\nQ: abbandona il torneo");
			printw("\nAltro tasto: aggiorna la classifica\n\n");
			refresh();
		}
		if((fp=fopen(robstring, "rb"))==NULL) uso();
		init(fp,0);
		fclose(fp);

		for(i=0;i<numrob;i++) for(j=0;j<3;j++) data[i][j]=0;

		if(f2f) {
			for(i=0;i<limrob;i++) {
				for(j=i+1;j<numrob;j++)
				{
					in[(long)c*2]=i;
					in[(long)(c++)*2+1]=j;
				 }
			}

			k=c;
			randomize();
			if (!ordine) {
				for(c=0;c<k;c++) scambiaf2f(c, c+rand()%(k-c), in);
			}
		}
		else {
			for(i=0;i<limrob;i++) {
				for(j=i+1;j<numrob;j++)
					for(k=j+1;k<numrob;k++)
						for(z=k+1;z<numrob;z++)
						{
							in[(long)c*4]=i;
							in[(long)c*4+1]=j;
							in[(long)c*4+2]=k;
							in[((long)(c++))*4+3]=z;
						}
			}

			for(i=1,k=0;i<=limrob;i++)
				k+=(int)((long)(numrob-i)*(long)(numrob-(i+1))*(long)(numrob-(i+2))/6);
			randomize();
			if (!ordine) {
				for(c=0;c<k;c++) scambia(c, c+rand()%(k-c), in);
			}
		}
	} else	{
		if(!quiet) {
			printw("\nContinuo il torneo salvato in precedenza\n\n");
			printw("\n\n\nDurante il torneo:\nS: salva la situazione\nQ: abbandona il torneo");
			printw("\nAltro tasto: aggiorna la classifica\n\n");
			refresh();
		}
		init(fp,1);
		fscanf(fp, "%d", &k);
		if(f2f) for(L=0;L<(2*(long)k);L++) fscanf(fp, "%d", &in[L]);
		else for(L=0;L<(4*(long)k);L++) fscanf(fp, "%d", &in[L]);
		for(i=0;i<numrob;i++) for(j=0;j<3;j++) {
			fscanf(fp,"%s",r);
			data[i][j]=atol(r);
		}
		if (fscanf(fp,"%s",temp)!=EOF) {
			bias=atol(temp);
			while (fgets(temp,80,fp)){
				if (toupper(temp[0])=='M' && strstr(temp,"=")) {
					if(!(matches=getval(temp))) matches=100;
				}
				else if (toupper(temp[0])=='X') rep=0;
				else if (toupper(temp[0])=='D') {
					strcpy(fileout,strstr(temp,"=")+1);
					isfileout=1;
					if(strchr(fileout,13))
					*(strchr(fileout,13))=0;
					if(strchr(fileout,10))
					*(strchr(fileout,10))=0;
				}
				else if (toupper(temp[0])=='T') log=2;
				else if (toupper(temp[0])=='C'&&!(extcount[0])) strcpy(extcount,strstr(temp,"=")+1);
			}
		}
		fclose(fp);
		strcpy(temp,dirstring);
		strcat(temp,".dat");
		remove(temp);

		if (log==2) {
			strcpy(temp,dirstring);
			strcat(temp,".log");
			if((flog=fopen(temp,"rt"))==NULL) {

				if(quiet) {
					printf("File di log non trovato\n");
					exit(-1);
				} else {
					printw("\nIl file %s non e' stato trovato\n Digitare S per continuare senza il log degli incontri\n",temp);
					refresh();
				#ifdef msdos
					while(!kbhit());
					if((z=getch())!='S' && z!='s') {
				#else
					if((z=getchar())!='S' && z!='s') {
				#endif
						endwin();
						exit(-1);
					}
					log=0;
				}

			}
			else fclose(flog);
		}
	}
	if(!rep) {
		rep=numinc;
		numinc=1;
	}
	if (log){
		strcpy(temp,dirstring);
		strcat(temp,".log");
		if(log==2) flog=fopen(temp,"ab");
		else flog=fopen(temp,"wb");
		if (flog==NULL) {
			endwin();
			printf("\n\nNon riesco a creare il file di log.\n");
			exit(-1);
		}
		if (log==1) {
			fprintf(flog,"Torneo gestito da %s di Michelangelo Messina\n",versio);
			fprintf(flog,"Numero incontri=%ld",((long)k)*numinc*rep);
		}
	}
	else if (extcount[0]) extcount[0]=0;
	#ifdef linux
	if(extcount[0]) if(!strstr(extcount,">/dev/null") ) {
		if(extcount[strlen(extcount)-1]==10) extcount[strlen(extcount)-1]=0;
		strcat(extcount," >/dev/null");
	}
	strcpy(pars,"crobots </dev/null >L 2>/dev/null -l200000 -m");
	strcpy(nr,"0000");
	#else
	strcpy(pars,"c<nul>L -l200000 -m");
	#endif
	if(f2f) {
		#ifdef msdos
		gotoxy(1,17);
		#endif
		nr[0]='0'+(numinc)/1000;
		nr[1]='0'+(numinc-1000*(int)((numinc)/1000))/100;
		nr[2]='0'+(numinc-100*(int)((numinc)/100))/10;
		nr[3]='0'+numinc%10;
		nr[4]=' ';
		nr[5]=0;
	} else {
		#ifdef msdos
		gotoxy(1,16);
		#endif
		nr[0]='0'+(numinc)/10;
		nr[1]='0'+(numinc)%10;
		nr[2]=' ';
		nr[3]=0;
	}
	strcat(pars,nr);
	strcat(pars,fk);
	chdir(dirstring);

	#ifdef linux
	if(!quiet) nodelay(stdscr,TRUE);
	#endif

	for(c=0;c<k;c++) {
		#ifdef linux
		if(!quiet) {
			move(23,1);
			printw("In corso: Match %d su %d",c+bias+1,k+bias);
			refresh();
		}
		#endif
		for(rp=0;rp<rep;rp++) {
			strcpy(parameter,pars);
			if(f2f) {
				mischiaf2f(c,in);
				strcat(parameter,srob[in[(long)c*2]]);
				strcat(parameter,srob[in[(long)c*2+1]]);
			}
			else {
				mischia(c,in);
				strcat(parameter,srob[in[(long)c*4]]);
				strcat(parameter,srob[in[(long)c*4+1]]);
				strcat(parameter,srob[in[(long)c*4+2]]);
				strcat(parameter,srob[in[(long)c*4+3]]);
			}
			#ifdef msdos
			if(fake) {
				gotoxy(1,21);
				printf("In corso: Match %ld su %ld",(long)c+bias+1,((long)k)+bias);
				clreol();
			}
			else if (f2f) gotoxy(1,17);
			else gotoxy(1,16);
			if(system(parameter)) {
				clrscr();
				/*printf("\nCMDLINE=%s\n",parameter);*/
				if(strlen(parameter)>123) printf("\nErrore DOS: riga di comando troppo lunga: %d caratteri\nRidurre la lunghezza dei path dei robot (max CMDLINE = 123 caratteri)\n",strlen(parameter));
				else printf("\nErrore DOS nell'esecuzione di crobots.exe\nProgramma interrotto\n");
				esci();
			}
			#else
			if(system(parameter)) {
				endwin();
				printf("\nCMDLINE=%s\n",parameter);
				printf("\nProgramma interrotto\n");
				esci();
			}
			#endif
			if(f2f) analisif2f();
			else analisi();

			if(!exitmode) {
				if((fp=fopen("cmnd","rt"))!=NULL) {
					aggiorna(k);
					fscanf(fp,"%s",temp);
					fclose(fp);
					remove("cmnd");
					if(!strcmp("save",temp)) exitmode=2;
					else if(!strcmp("quit",temp)) {
						exitmode=1;
						break;
					}
				}
				#ifdef linux
				else if((fp=fopen("../cmnd","rt"))!=NULL) {
				#else
				else if((fp=fopen("..\\cmnd","rt"))!=NULL) {
				#endif
					aggiorna(k);
					fscanf(fp,"%s",temp);
					fclose(fp);
					if(!strcmp("save",temp)) exitmode=2;
					else if(!strcmp("quit",temp)) {
						exitmode=1;
						break;
					}
				}
				#ifdef linux
				else if(!quiet) {
					if((z=getch())!=ERR) {
						aggiorna(k);
						if(z=='q'||z=='Q'||z=='s'||z=='S') {
							if(z=='s'||z=='S') exitmode=2;
							else {
								exitmode=1;
								break;
							}
						}
					}
				}
				#else
				if(kbhit()) {
					aggiorna(k);
					if((z=getch())=='q' || z=='Q' || z=='s' ||z=='S') {
						if(z=='s' || z=='S') exitmode=2;
						else {
							exitmode=1;
							break;
						}
					}
				}
				#endif
			}
		}
		if(exitmode==2) save(k);
		if(exitmode) break;
		else if(!((c+1)%matches))aggiorna(k);
	}
	if(c==k) c--;
	if (log) fclose(flog);
	finale();
	remove("L");
	#ifdef msdos
	remove("c.exe");
	for(i=0;i<numrob;i++) remove(srob[i]);
	#else
	for(i=0;i<numrob;i++) {
		strcpy(temp,srob[i]);
		if(strstr(temp," ")) *(strstr(temp," "))=0;
		if(strstr(temp,"\\")) strcpy(strstr(temp,"\\"),strstr(temp,"\\")+1);
		remove(temp);
	}
	#endif
	chdir("..");
	rmdir(dirstring);
	exit(0);
	return(0);
}

void	init(FILE *fp, char status)
{
	char	i;
	int	tipo;
	FILE	*test;

	if(status){
		mtest=0;
		rtest=0;
		rep=1;
		log=0;
		fscanf(fp, "%d",&tipo);
		if(f2f != tipo) {
			endwin();
			printf("Il torneo in corso e' di tipo diverso!\n");
			exit(-1);
		}

	}
	fscanf(fp, "%d",&numrob);
	if(!numrob) errore(status);
	fscanf(fp, "%d",&numinc);
	if(mtest) numinc=mnuminc;
	if(!numinc) errore(status);
	numrob+=rtest;
	for(i=rtest;i<numrob;i++) if(fscanf(fp,"%s",rob[i])==EOF) errore(status);
	#ifdef djgpp
	if (mkdir(dirstring,S_IWUSR)) {
	#else
	if (mkdir(dirstring)) {
        #endif
		endwin();
		fclose(fp);
		printf("\n\nE' in corso un'altro torneo nella directory %s !\n",dirstring);
		printf("\nSe la directory %s e' stata creata da una esecuzione non andata a buon fine,\n eliminarla prima di lanciare %s\n",dirstring,versio);
		printf("\n\nAltrimenti utilizzare -d=xxxx per cambiare directory di destinazione\n");
		exit(-1);
	}
	#ifdef msdos
	patch();
	#else
	strcpy(temp,"chmod a=rwx ");
	strcat(temp,dirstring);
	system(temp);
	#endif

	for(i=0;i<numrob;i++) {
		strcpy(srob[i],rob[i]);
		if(strchr(rob[i],13))
		*(strchr(rob[i],13))=0;
		if(strchr(rob[i],10))
		*(strchr(rob[i],10))=0;
		strcpy(srob[i],rob[i]);

		strcpy(temp,srob[i]);
		if(strstr(temp," ")) *(strstr(temp," "))=0;
		#ifdef linux
		if(strstr(temp,"\\")) strcpy(strstr(temp,"\\"),strstr(temp,"\\")+1);
		#endif
		if((test=fopen(temp,"r"))!=NULL) fclose(test);
		else errore(2);

		strcat(srob[i]," ");
		#ifdef linux
		strcpy(temp,"ln -s >/dev/null ");
		if(srob[i][0]!='/') strcat(temp,"../");
		strcat(temp,srob[i]);
		strcat(temp,dirstring);
		while(strstr(srob[i],"/"))strcpy(srob[i],strstr(srob[i],"/")+1);
		#else
		strcpy(temp,"copy >nul ");
		strcat(temp,srob[i]);
		while(strstr(srob[i],":")) strcpy(srob[i],strstr(srob[i],":")+1);
		while(strstr(srob[i],"\\")) strcpy(srob[i],strstr(srob[i],"\\")+1);
		strcat(temp,dirstring);
		#endif
		if(system(temp)) {
			endwin();
			printf("Errore nell'apertura dei files\n");
			exit(-1);
		}

		if(strstr(srob[i],".pr")) {
			#ifdef linux
			strcpy(temp,"ppc </dev/null >/dev/null ");
			#else
			strcpy(temp,"ppc <nul >nul ");
			#endif
			strcat(temp,dirstring);
			#ifdef linux
			strcat(temp,"/");
			#else
			strcat(temp,"\\");
			#endif
			strcat(temp,srob[i]);
			if(system(temp)) {
				endwin();
				printf("\nErrore nel file %s.rob\no nell'utilizzo del preprocessore\n",dirstring);
				exit(-1);
			}

			strcpy(temp,dirstring);
			#ifdef linux
			strcat(temp,"/");
			#else
			strcat(temp,"\\");
			#endif
			strcat(temp,srob[i]);
			if(strstr(temp," ")) *(strstr(temp," "))=0;
			remove(temp);

			*(strstr(srob[i],"."))=0;
			strcat(srob[i],".r ");
		}

		if(!strstr(srob[i],".r")) errore(2);
	}

	if (status) return;

	while (fgets(temp,80,fp)){
		if (toupper(temp[0])=='L' && strstr(temp,"=") &&(!limrob)) limrob=getval(temp);
		else if (toupper(temp[0])=='M' && strstr(temp,"=")) {
			if(!(matches=getval(temp))) matches=100;
		}
		else if (toupper(temp[0])=='X') rep=0;
		else if (toupper(temp[0])=='D') {
			strcpy(fileout,strstr(temp,"=")+1);
			isfileout=1;
			if(strchr(fileout,13))
			*(strchr(fileout,13))=0;
			if(strchr(fileout,10))
			*(strchr(fileout,10))=0;

		}
		else if (toupper(temp[0])=='T') log=1;
		else if (toupper(temp[0])=='O') ordine=1;
		else if (toupper(temp[0])=='C'&&!extcount[0]) strcpy(extcount,strstr(temp,"=")+1);

	}
	if ((!limrob)||(limrob>numrob)) limrob=numrob;
}

void	scambia(int i,int j,char *in)
{
	char k,temp;
	for(k=0;k<4;k++) {
		temp=in[(long)j*4+(long)k];
		in[(long)j*4+(long)k]=in[(long)i*4+(long)k];
		in[(long)i*4+(long)k]=temp;
	}

}

void mischia(int j, char *in)
{
	char k,temp,z;
	for(k=0;k<4;k++) {
		z=rand()%(4);
		temp=in[(long)j*4+(long)z];
		in[(long)j*4+(long)z]=in[(long)j*4+(long)k];
		in[(long)j*4+(long)k]=temp;
	}
}

void save(int k)
{
	long	L;
	char	i,j;
	FILE	*fp;

	#ifdef msdos
	strcpy(temp,"..\\");
	#else
	strcpy(temp,"../");
	#endif
	strcat(temp,dirstring);
	strcat(temp,".dat");
	if((fp=fopen(temp,"wt"))!=NULL) {
		fprintf(fp, "%d\n",f2f);
		fprintf(fp, "%d\n",numrob);
		if(rep==1) fprintf(fp, "%d\n",numinc);
		else fprintf(fp,"%d\n",rep);
		for(i=0;i<numrob;i++)
			fprintf(fp,"%s\n",rob[i]);
		fprintf(fp,"%u\n",k-c-1);

		if(f2f) for(L=(2*((long)c+1));L<(2*(long)k);L++) {
			fprintf(fp, "%d\n", in[L]);
		}
		else for(L=(4*((long)c+1));L<(4*(long)k);L++) {
			fprintf(fp, "%d\n", in[L]);
		}
		for(i=0;i<numrob;i++)
			for(j=0;j<3;j++) fprintf(fp,"%ld\n",data[i][j]);
		fprintf(fp,"%d\n", bias+c+1);
		if (matches!=100) fprintf(fp, "M=%d\n", matches);
		if (rep!=1) fprintf(fp, "X\n");
		if (log) fprintf(fp, "T\n");
		if (extcount[0]) fprintf(fp, "C=%s\n",extcount);
		if (isfileout) fprintf(fp, "D=%s\n", fileout);
		fclose(fp);
		if (!quiet) printf("\n\n Situazione salvata nel file  %s.dat\n",dirstring);
	}
	else {
		endwin();
		printf("Errore nel salvataggio!\n");
		esci();
	}
}



void analisi()
{
	char	buffer[17][80];
	int	i,j,k;
	FILE	*fp;
	char	car,ncar;


	if((fp=fopen("L", "rt"))==NULL) {
		endwin();
		printf("Errore nel caricamento di L\n");
		esci();
	}
	i=0;
	while (!feof(fp)) {
		fscanf(fp,"%s",buffer[((++i)%17)]);
	}
	fclose (fp);

	if(log) {
		if((fp=fopen("L", "rb"))==NULL) {
			endwin();
			printf("Errore nel caricamento di L\n");
			esci();
		}
		car=fgetc(fp);
		while (!feof(fp)) {
			ncar=fgetc(fp);
			if(fputc(car,flog)==EOF) {
				endwin();
				printf("Errore nella scrittura del log\n");
				fclose(fp);
				esci();
			}
			car=ncar;
		}
		fflush(flog);
		fclose(fp);
	}

	i++;

	for(j=0;j<4;j++)
	{
		k=in[c*4+j];
		data[k][0]+=numinc;
		data[k][1]+=getval((char *)buffer[((i+4*j+2)%17)]);
		data[k][2]+=getval((char *)buffer[((i+4*j+3)%17)]);

	}
	if(strspn(buffer[(i+13)%17],srob[in[c*4+3]])!=(strlen(srob[in[c*4+3]])-1)) {
		endwin();
		printf("\n\nErrore nella compilazione di un robot!\n");
		esci();
	}

/*	#ifdef msdos
	gotoxy(1,16);
	#endif
 */
}


void	aggiorna(unsigned int nr)
{
	FILE	*fp;


	chdir("..");
	if(extcount[0]) system(extcount);
	if (isfileout) {
		if((fp=fopen(fileout, "wt"))==NULL) {
			endwin();
			printf("Errore nella scrittura dei risultati\n");
			esci();
		}
		stampa(fp,100,nr);
		fclose(fp);
	}
	if(!quiet) {
		#ifdef msdos
		clrscr();
		gotoxy(1,1);
		stampa(stdout,19,nr);
		#else
		stampaw(nr);
		#endif
	}
	chdir(dirstring);

/*	#ifdef msdos
	if (f2f) gotoxy(1,17);
	else gotoxy(1,16);
	#endif
*/
}

int	getval(char *from)
{
	char *r;
	r=strchr(from,'=');
	return(atoi(r+1));
}

void finale()
{
	FILE	*fp;

	chdir("..");
	if(extcount[0]) system(extcount);
	clrscr();
	endwin();
	if((fp=fopen(fileout,"wt"))==NULL) {
		printf("\nRisultati non salvati!\n");
		chdir(dirstring);
		esci();
	}
	stampa(fp,100,0);
	fclose(fp);
	if(!quiet) {
		stampa(stdout,24,0);
		printf("\n\n I risultati sono stati salvati nel file %s\n",fileout);
	}
	chdir(dirstring);
}

void stampa(FILE *fp,int maxrow, unsigned int nr)
{
	int	i,j,temp,classifica[25];
	float	media[25];

	for(i=0;i<numrob;i++) {
		if(data[i][0])
		media[i]=(float)(100*((float)data[i][1]+(float)data[i][2]*pari/win)/(float)data[i][0]);
		else media[i]=-1;
	}
	for(i=0;i<numrob;i++) classifica[i]=i;
	if (!nr) fprintf(fp, " Risultati finali:\n");
	else fprintf(fp," Risultati dopo %ld incontri su %ld (%d %%):\n",(long)c+1+bias,(long)nr+bias,(((long)(c+bias+1)*(long)100))/(long)(nr+bias));
	fprintf(fp,"Pos -   Robot - partite - vinte - patte - perse -    punti -   eff.%\n");
	for(i=0;i<numrob;i++) {
		for(j=i;j<numrob;j++) {
			if(media[classifica[i]]<media[classifica[j]]) {
				temp=classifica[i];
				classifica[i]=classifica[j];
				classifica[j]=temp;
			}
		}
	}
	for(i=0;i<numrob&&i<maxrow;i++) {
		if(data[classifica[i]][0])
		fprintf(fp,"%2d%14s %5ld   %6ld   %5ld   %5ld   %8.0f    %6.2f\n",(i+1),srob[classifica[i]],
		data[classifica[i]][0], data[classifica[i]][1],
		data[classifica[i]][2], data[classifica[i]][0]-data[classifica[i]][1]-data[classifica[i]][2],
		(float) data[classifica[i]][1]*win+(float)data[classifica[i]][2]*pari,
		media[classifica[i]]);
		else fprintf(fp,"%2d%14s\n",(i+1),srob[classifica[i]]);
	}
}

#ifdef linux
void stampaw(int nr)
{
	int	i,j,temp,classifica[25];
	float	media[25];

	for(i=0;i<numrob;i++) {
		if(data[i][0])
		media[i]=(float)(100*((float)data[i][1]+(float)data[i][2]*pari/win)/(float) data[i][0]);
		else media[i]=-1;
	}
	for(i=0;i<numrob;i++) classifica[i]=i;
	clear();
	printw(" Risultati dopo %d incontri su %d (%d %%):\n",c+1+bias,nr+bias,(((long)(c+bias+1)*100))/(nr+bias));
	printw("Pos -   Robot - partite - vinte - patte - perse -    punti -   eff.%\n");
	for(i=0;i<numrob;i++) {
		for(j=i;j<numrob;j++) {
			if(media[classifica[i]]<media[classifica[j]]) {
				temp=classifica[i];
				classifica[i]=classifica[j];
				classifica[j]=temp;
			}
		}
	}
	for(i=0;i<numrob&&i<21;i++) {
		if(data[classifica[i]][0])
		printw("%2d%14s %5ld   %6ld   %5ld   %5ld   %8.0f    %6.2f\n",(i+1),srob[classifica[i]],
		data[classifica[i]][0],	data[classifica[i]][1],
		data[classifica[i]][2],data[classifica[i]][0]-data[classifica[i]][1]-data[classifica[i]][2],
		(float) data[classifica[i]][1]*win+(float)data[classifica[i]][2]*pari,
		media[classifica[i]]);
		else printw("%2d%14s\n",(i+1),srob[classifica[i]]);
	}
}
#else
void patch()
{
	unsigned long 	c,l;
	char	i,j,buf[10],temp[128];
	FILE	*fp1,*fp2,*fp;

	if((fp1=fopen("crobots.exe","rb"))==NULL) {
		printf("Il file CROBOTS.EXE deve essere nella directory corrente!\n");
		exit(-1);
	}

	if(filelength(fileno(fp1))!=60224) fake=1;

	strcpy(temp,dirstring);
	strcat(temp,"\\c.exe");
	if((fp2=fopen(temp,"wb"))==NULL) {
		printf("Errore in scrittura!\n");
		fclose(fp1);
		exit(-1);
	}
	if((fp=fopen("patch.dat","rb"))==NULL) {
		printf("Il file PATCH.DAT deve essere nella directory corrente!\n");
		fclose(fp1);
		fclose(fp2);
		exit(-1);
	}
	if(fake) strcpy(fk,"-g ");
	l=atol(fgets(buf,10,fp));
	for(c=0;!feof(fp1);c++) {
		i=fgetc(fp1);
		if(c==l&& !fake) {
			fscanf(fp,"%d",&j);
			fputc(j,fp2);
			fscanf(fp,"%u",&l);
		}
		else  fputc(i,fp2);
	}
	fclose(fp1);
	fclose(fp2);
	fclose(fp);
}
#endif
void esci()
{
	#ifdef msdos
	remove("c.exe");
	#endif
	if (log) fclose(flog);
	chdir("..");
	exit(-1);
}

void	scambiaf2f(int i,int j,char *in)
{
	char k,temp;
	for(k=0;k<2;k++) {
		temp=in[(long)j*2+(long)k];
		in[(long)j*2+(long)k]=in[(long)i*2+(long)k];
		in[(long)i*2+(long)k]=temp;
	}

}

void mischiaf2f(int j, char *in)
{
	char k,temp,z;
	for(k=0;k<2;k++) {
		z=rand()%(2);
		temp=in[(long)j*2+(long)z];
		in[(long)j*2+(long)z]=in[(long)j*2+(long)k];
		in[(long)j*2+(long)k]=temp;
	}
}

void analisif2f()
{
	char	buffer[10][80];
	int	i,j,k;
	FILE	*fp;
	char	car,ncar;


	if((fp=fopen("L", "rt"))==NULL) {
		endwin();
		printf("Errore nel caricamento di L\n");
		esci();
	}
	i=0;
	while (!feof(fp)) {
		fscanf(fp,"%s",buffer[((++i)%10)]);
	}
	fclose (fp);

	if(log) {
		if((fp=fopen("L", "rb"))==NULL) {
			endwin();
			printf("Errore nel caricamento di L\n");
			esci();
		}
		car=fgetc(fp);
		while (!feof(fp)) {
			ncar=fgetc(fp);
			if(fputc(car,flog)==EOF) {
				endwin();
				printf("Errore nella scrittura del log\n");
				fclose(fp);
				esci();
			}
			car=ncar;
		}
		fflush(flog);
		fclose(fp);
	}

	i++;

	if(i<3) {
		endwin();
		printf("\n\nErrore nella compilazione di un robot!\n");
		esci();
	}
	for(j=0;j<2;j++)
	{
		k=in[c*2+j];
		data[k][0]+=numinc;
		data[k][1]+=getval((char *)buffer[((i+4*j+3)%10)]);
		data[k][2]+=getval((char *)buffer[((i+4*j+4)%10)]);

	}

/*	#ifdef msdos
	gotoxy(1,17);
	#endif
*/
}

void uso()
{
	if(quiet) printf("Errore - digitare t2k ? per ottenere l'aiuto\n");
	else {
		clear();
		#ifdef linux
		printw("Uso: t2k [switches] [file di comando[.rob]]\n");
		printw("     t2k save|quit|agg [nometorneo]\n");
		#else
		printw("Uso: Torneo2k [switches] [file di comando[.rob]]\n");
		printw("     Torneo2k save|quit|agg [nometorneo]\n");
		#endif
		printw("Per default il file di comando e' torneo.rob\n\n");
		printw("Switches:\n\n");
		printw("-d=x  : files di output del tipo x.est\n");
		printw("-r=x.r: aggiunge x.r come primo robot\n");
		printw("-f    : attiva modalita' Face2Face\n");
		printw("-x    : avvia piu' volte crobots\n");
		printw("-m=x  : x incontri per match \n");
		printw("-t    : crea il file di log  \n");
		#ifdef msdos
		printw("\"-c=x\": esegue il prog. esterno di conteggio (p.es. \"-c=count73 torneo /a\")\n");
		#else
		printw("\"-c=x\": esegue il prog. esterno di conteggio (p.es. \"-c=count73 torneo -a\")\n");
		#endif
		printw("-o    : torneo ordinato\n");
		printw("-l=x  : torneo completato dai primi x robots\n");
		#ifdef linux
		printw("-q    : modalita' 'QUIET' per i batch\n");
		#endif
		printw("-w=x  : assegna x punti per vittoria (default=3)\n");
		printw("-p=x  : assegna x punti per il pareggio (default=1)\n");
		printw("\n\nQuesti switches hanno la priorita' su quelli inseriti nel file di comando\n");
		printw("\n\n Premi un tasto\n");
		refresh();
		#ifdef msdos
		while(!kbhit());
		getch();
		#else
		getchar();
		#endif
		clear();
		printw("\nIl file di comando deve contenere:\nnumero robot\nnumero incontri\nrobot del torneo (max %d, comprensivi di path)\n\n",MAXROB);
		printw("Opzioni da inserire dopo l'ultimo robot, obbligatoriamente senza spazi:\n\nL=n (con n <=numero robot)\n     ");
		printw("per far giocare solo gli incontri dei primi n robots\n");
		printw("O    per avere il torneo in ordine\n");
		printw("M=n  per avere l'aggiornamento della situazione ogni n partite (default 100)\n");
		printw("X    per avviare piu' volte crobots col parametro -m1\n");
		printw("D=fileoutput\n     per avere l'aggiornamento su un file diverso dal default (.sco)\n");
		printw("T    per conservare il log completo degli incontri (.log)\n");
		printw("C=fileconteggio (da usare in congiunzione all'opzione T - creazione log)\n     per usare un programma esterno per l'analisi\n");
		printw("\n\n Premi un tasto\n");
		refresh();
		#ifdef msdos
		while(!kbhit());
		getch();
		#else
		getchar();
		#endif
		endwin();
	}
	exit(-1);

}
void comando(char* cm,int argc, char *argv[])
{
	FILE *fp;


	printf("\n\n\n\n\nCROBOTS %s\nCopyright (C) Michelangelo Messina\n",versio);
	printf("e-mail m.messina@tiscalinet.it\n       m.messina@libero.it\n\n\n\n");

	if (argc>2) {
		strcpy(temp,argv[2]);
		if(temp[strlen(temp)-1] !='/') strcat(temp,"/");
		strcat(temp,"cmnd");
	}
	else {
		if(!strcmp(cm,"aggiorna")) {
			printf("Errore\nSpecificare il nome del torneo\n");
			exit(-1);
		}
		strcpy(temp,"cmnd");
	}
	if((fp=fopen(temp,"wt"))==NULL) {
		printf("Errore\nFile %s non creato\n",temp);
		exit(-1);
	}
	fprintf(fp,"%s\n",cm);
	fclose(fp);
	printf("Inviato comando %s\n",cm);
	exit(0);
}
void errore(char status)
{
	endwin();
	if(!status) printf("\nErrore nel file .rob\n");
	else if(status==1) printf("\nErrore nel file .dat\n");
	else printf("\nErrore nella compilazione di un robot\n");
	exit(-1);
}

#ifndef __TURBOC__
void randomize(void)
{
	long ltime;

	ltime=time(NULL);
	srand( (unsigned int)(ltime/2));
}
#endif

#ifdef msdos
void refresh(void){}
void initscr(void){}
void cbreak(void) {}
void noecho(void) {}
void curs_set(int x) {}
void endwin(void) {strcpy(temp,dirstring);strcat(temp,"\\c.exe");remove(temp); }
#endif
